summaryrefslogtreecommitdiffstats
path: root/system/nvidia-open-kernel
diff options
context:
space:
mode:
Diffstat (limited to 'system/nvidia-open-kernel')
-rw-r--r--system/nvidia-open-kernel/10-nvidia.conf11
-rw-r--r--system/nvidia-open-kernel/README66
-rw-r--r--system/nvidia-open-kernel/doinst.sh3
-rw-r--r--system/nvidia-open-kernel/nvidia-open-kernel.SlackBuild109
-rw-r--r--system/nvidia-open-kernel/nvidia-open-kernel.info10
-rw-r--r--system/nvidia-open-kernel/slack-desc19
6 files changed, 218 insertions, 0 deletions
diff --git a/system/nvidia-open-kernel/10-nvidia.conf b/system/nvidia-open-kernel/10-nvidia.conf
new file mode 100644
index 0000000000..cc09382e41
--- /dev/null
+++ b/system/nvidia-open-kernel/10-nvidia.conf
@@ -0,0 +1,11 @@
+# This xorg.conf.d configuration snippet configures the X server to
+# automatically load the nvidia X driver when it detects a device driven by the
+# nvidia-drm.ko kernel module. Please note that this only works on Linux kernels
+# version 3.9 or higher with CONFIG_DRM enabled, and only if the nvidia-drm.ko
+# kernel module is loaded before the X server is started.
+
+Section "OutputClass"
+ Identifier "nvidia"
+ MatchDriver "nvidia-drm"
+ Driver "nvidia"
+EndSection
diff --git a/system/nvidia-open-kernel/README b/system/nvidia-open-kernel/README
new file mode 100644
index 0000000000..280c3d66f9
--- /dev/null
+++ b/system/nvidia-open-kernel/README
@@ -0,0 +1,66 @@
+This is the open-source version of the kernel module needed by the
+proprietary binary nvidia driver. It is provided as an alterative to
+the nvidia-kernel SBo script that builds the modules from the binary
+Nvidia package. Note that it CANNOT be installed with the
+nvidia-kernel package, but you will still need the nvidia-driver
+package from SlackBuilds.org.
+
+To build the package for a kernel different from the running one,
+start the script setting the KERNEL variable as in
+ KERNEL=4.6.3 ./nvidia-open-kernel.SlackBuild
+
+A default config file is placed at
+ /usr/share/X11/xorg.conf.d/10-nvidia.conf
+to make sure that X loads the nvidia module. If you need to make
+changes, move that file to /etc/X11/xorg.conf.d/ and edit the copy.
+You do not need this file at all if you have a proper and complete
+xorg.conf.
+
+The xf86-video-nouveau-blacklist package from /extra is required.
+
+NOTES (quoted from the Nvidia driver README)
+
+"The open flavor of kernel modules supports Turing and later GPUs. The
+open kernel modules cannot support GPUs before Turing, because the open
+kernel modules depend on the GPU System Processor (GSP) first
+introduced in Turing.
+
+"Most features of the Linux GPU driver are supported with the open
+flavor of kernel modules, including CUDA, Vulkan, OpenGL, OptiX, and
+X11. We eventually intend for the open kernel modules to replace the
+proprietary kernel modules.
+
+"The following features will only work with the open kernel modules
+flavor of the driver:
+
+ o NVIDIA Confidential Computing
+
+ o Magnum IO GPUDirect Storage (GDS)
+
+ o Heterogeneous Memory Management (HMM)
+
+ o CPU affinity for GPU fault handlers
+
+ o DMABUF support for CUDA allocations
+
+
+"The following features are not yet supported by the open kernel
+modules:
+
+ o G-Sync on notebooks
+
+ o Preserving video memory across power management events
+
+
+Use of the open kernel modules on GeForce and Workstation GPUs should
+be considered Beta quality in this release and no longer requires
+setting of the "NVreg_OpenRmEnableUnsupportedGpus" nvidia.ko kernel
+module parameter. The open kernel modules are suitable for broad
+usage, and NVIDIA requests feedback on any issues encountered that are
+specific to them."
+
+After installation, you will need to reboot your computer for the
+changes to take effect.
+
+I am happy to report that ffmpeg hardware video encoding via h264_nvenc
+and hevc_nvenc now WORKS with this module.
diff --git a/system/nvidia-open-kernel/doinst.sh b/system/nvidia-open-kernel/doinst.sh
new file mode 100644
index 0000000000..dcfb80855f
--- /dev/null
+++ b/system/nvidia-open-kernel/doinst.sh
@@ -0,0 +1,3 @@
+
+chroot . /sbin/depmod -a @KERNEL@ 2>/dev/null
+
diff --git a/system/nvidia-open-kernel/nvidia-open-kernel.SlackBuild b/system/nvidia-open-kernel/nvidia-open-kernel.SlackBuild
new file mode 100644
index 0000000000..2b537d8023
--- /dev/null
+++ b/system/nvidia-open-kernel/nvidia-open-kernel.SlackBuild
@@ -0,0 +1,109 @@
+#!/bin/bash
+
+# Slackware build script for nvidia-open-kernel
+
+# Copyright 2022 Lenard Spencer, Orlando, FL, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ''AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+# Thanks to Robby Workman for suggestions to improve this script.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=nvidia-open-kernel
+VERSION=${VERSION:-550.78}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+KERNEL=${KERNEL:-$(uname -r)}
+KERNELPATH=${KERNELPATH:-/lib/modules/${KERNEL}/build}
+
+set -e
+
+PKGVER=${VERSION}_$(echo $KERNEL | tr - _)
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ "$ARCH" = "x86_64" ]; then
+ TARGET="x86_64"
+else
+ echo "$ARCH is not supported."
+ exit 1
+fi
+
+unset ARCH
+
+SRCNAM=NVIDIA-kernel-module-source-${VERSION}
+
+# If the variable PRINT_PACKAGE_NAME is set, then this script will report what
+# the name of the created package would be, and then exit. This information
+# could be useful to other scripts.
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$PKGVER-$TARGET-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP || exit 1
+rm -rf $SRCNAM
+tar -xvf $CWD/$SRCNAM.tar.?z || exit 1
+cd $SRCNAM || exit 1
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+# CC=${CC:-gcc} suppresses an otherwise harmless "compiler mismatch"
+# message. If you custom-build your kernel with clang,
+# then pass CC=clang to this script.
+CC=${CC:-gcc} make SYSSRC=$KERNELPATH modules || exit 1
+
+mkdir -p $PKG/lib/modules/$KERNEL/kernel/drivers/video
+install -m 0664 kernel-open/nvidia.ko $PKG/lib/modules/$KERNEL/kernel/drivers/video/
+install -m 0664 kernel-open/nvidia-modeset.ko $PKG/lib/modules/$KERNEL/kernel/drivers/video/
+install -m 0664 kernel-open/nvidia-drm.ko $PKG/lib/modules/$KERNEL/kernel/drivers/video/
+install -m 0664 kernel-open/nvidia-uvm.ko $PKG/lib/modules/$KERNEL/kernel/drivers/video/
+
+mkdir -p $PKG/usr/share/X11/xorg.conf.d/
+cat $CWD/10-nvidia.conf > $PKG/usr/share/X11/xorg.conf.d/10-nvidia.conf
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$PKGVER
+cp -a README.md CHANGELOG.md SECURITY.md $PKG/usr/doc/$PRGNAM-$PKGVER
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$PKGVER/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+sed "s%@VERSION@%$VERSION%" $CWD/slack-desc > $PKG/install/slack-desc
+sed "s%@KERNEL@%$KERNEL%" $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$PKGVER-$TARGET-$BUILD$TAG.$PKGTYPE
diff --git a/system/nvidia-open-kernel/nvidia-open-kernel.info b/system/nvidia-open-kernel/nvidia-open-kernel.info
new file mode 100644
index 0000000000..eb2890eb1b
--- /dev/null
+++ b/system/nvidia-open-kernel/nvidia-open-kernel.info
@@ -0,0 +1,10 @@
+PRGNAM="nvidia-open-kernel"
+VERSION="550.78"
+HOMEPAGE="https://github.com/NVIDIA/open-gpu-kernel-modules/"
+DOWNLOAD="UNSUPPORTED"
+MD5SUM=""
+DOWNLOAD_x86_64="https://download.nvidia.com/XFree86/NVIDIA-kernel-module-source/NVIDIA-kernel-module-source-550.78.tar.xz"
+MD5SUM_x86_64="fd8640459f2b68ae2f8f98bc795707e8"
+REQUIRES=""
+MAINTAINER="Lenard Spencer"
+EMAIL="lenardrspencer@gmail.com"
diff --git a/system/nvidia-open-kernel/slack-desc b/system/nvidia-open-kernel/slack-desc
new file mode 100644
index 0000000000..dc783a7f0f
--- /dev/null
+++ b/system/nvidia-open-kernel/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+nvidia-open-kernel: nvidia-open-kernel (Open kernel Interface for the nvidia driver)
+nvidia-open-kernel:
+nvidia-open-kernel: This is the source release of the NVIDIA Linux open GPU kernel
+nvidia-open-kernel: modules, version @VERSION@. It is meant as an open source
+nvidia-open-kernel: alternative to the proprietary nvidia-kernel. See README.md for
+nvidia-open-kernel: supported GPUs.
+nvidia-open-kernel: Note that it CANNOT be installed alongside the proprietary
+nvidia-open-kernel: nvidia-kernel SBo package.
+nvidia-open-kernel:
+nvidia-open-kernel: https://github.com/NVIDIA/open-gpu-kernel-modules/
+nvidia-open-kernel: